Overview | Package | Class | Deprecated | Index | Help
| Groovy Documentation
| FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.codehaus.groovy.ast
[Java] Class ClassNode

    java.lang.Object
      org.codehaus.groovy.ast.ASTNode
          org.codehaus.groovy.ast.AnnotatedNode
              org.codehaus.groovy.ast.ClassNode

All Implemented Interfaces:
  org.objectweb.asm.Opcodes

    public class ClassNode
    extends AnnotatedNode

Represents a class in the AST.
A ClassNode should be created using the methods in ClassHelper. This ClassNode may be used to represent a class declaration or any other type. This class uses a proxy mechanism allowing to create a class for a plain name at AST creation time. In another phase of the compiler the real ClassNode for the plain name may be found. To avoid the need of exchanging this ClassNode with an instance of the correct ClassNode the correct ClassNode is set as redirect. Most method calls are then redirected to that ClassNode.
There are three types of ClassNodes:

1. Primary ClassNodes:
   A primary ClassNode is one where we have a source representation which is to be compiled by Groovy and which we have an AST for. The groovy compiler will output one class for each such ClassNode that passes through AsmBytecodeGenerator... not more, not less. That means for example Closures become such ClassNodes too at some point.
2. ClassNodes create through different sources (typically created from a java.lang.reflect.Class object):
   The compiler will not output classes from these, the methods usually do not contain bodies. These kind of ClassNodes will be used in different checks, but not checks that work on the method bodies. For example if such a ClassNode is a super class to a primary ClassNode, then the abstract method test and others will be done with data based on these. Theoretically it is also possible to mix both (1 and 2) kind of classes in a hierarchy, but this probably works only in the newest Groovy versions. Such ClassNodes normally have to isResolved() returning true without having a redirect.In the Groovy compiler the only version of this, that exists, is a ClassNode created through a Class instance
3. Labels:
   ClassNodes created through ClassHelper.makeWithoutCaching. They are place holders, its redirect points to the real structure, which can be a label too, but following all redirects it should end with a ClassNode from one of the other two categories. If ResolveVisitor finds such a node, it tries to set the redirects. Any such label created after ResolveVisitor has done its work needs to have a redirect pointing to case 1 or 2. If not the compiler may react strange... this can be considered as a kind of dangling pointer.
   Note: the redirect mechanism is only allowed for classes that are not primary ClassNodes. Typically this is done for classes created by name only. The redirect itself can be any type of ClassNode.
   To describe generic type signature see getGenericsTypes() and setGenericsTypes(GenericsType[]). These methods are not proxied, they describe the type signature used at the point of declaration or the type signatures provided by the class. If the type signatures provided by the class are needed, then a call to redirect() will help.
   Authors:
     James Strachan
     Jochen Theodorou
   Version:
     \$Revision\$
   See Also:
     ClassHelper

   Field Summary
   `static ClassNode[]` | `EMPTY_ARRAY`
   `static ClassNode` | `SUPER`
   `static ClassNode` | `THIS`
   `protected java.lang.Class` | `clazz`
   `protected java.util.List` | `innerClasses`
   `protected boolean` | `isPrimaryNode`
   `protected java.lang.Object` | `lazyInitLock`

   Method Summary
   `java.lang.Object` | `ClassNode(java.lang.Class c)`
   `java.lang.Object` | `ClassNode(java.lang.String name, int modifiers, ClassNode superClass)`
   `java.lang.Object` | `ClassNode(java.lang.String name, int modifiers, ClassNode superClass, ClassNode[] interfaces, MixinNode[] mixins)`
   `void` | `addConstructor(ConstructorNode node)`
   `ConstructorNode` | `addConstructor(int modifiers, Parameter[] parameters, ClassNode[] exceptions, Statement code)`
   `void` | `addField(FieldNode node)`
   `FieldNode` | `addField(java.lang.String name, int modifiers, ClassNode type, Expression initialValue)`
   `void` | `addFieldFirst(FieldNode node)`
   `FieldNode` | `addFieldFirst(java.lang.String name, int modifiers, ClassNode type, Expression initialValue)`
   `void` | `addInterface(ClassNode type)`
   `void` | `addMethod(MethodNode node)`
   `MethodNode` | `addMethod(java.lang.String name, int modifiers, ClassNode returnType, Parameter[] parameters, ClassNode[] exceptions, Statement code)`
   `void` | `addMixin(MixinNode mixin)`
   `void` | `addObjectInitializerStatements(Statement statements)`
   `void` | `addProperty(PropertyNode node)`
   `PropertyNode` | `addProperty(java.lang.String name, int modifiers, ClassNode type, Expression initialValueExpression, Statement getterBlock, Statement setterBlock)`
   `void` | `addStaticInitializerStatements(java.util.List staticStatements, boolean fieldInit)`
   `MethodNode` | `addSyntheticMethod(java.lang.String name, int modifiers, ClassNode returnType, Parameter[] parameters, ClassNode[] exceptions, Statement code)`
   `void` | `addTransform(java.lang.Class transform, ASTNode node)`
   `boolean` | `declaresInterface(ClassNode classNode)` @return the ClassNode of the super class of this type
   `boolean` | `equals(java.lang.Object o)`
   `java.util.List` | `getAbstractMethods()`
   `java.util.List` | `getAllDeclaredMethods()`
   `java.util.Set` | `getAllInterfaces()`
   `java.util.List` | `getAnnotations()`
   `java.util.List` | `getAnnotations(ClassNode type)`
   `CompileUnit` | `getCompileUnit()`
   `ClassNode` | `getComponentType()`
   `java.util.List` | `getDeclaredConstructors()`
   `FieldNode` | `getDeclaredField(java.lang.String name)` Finds a field matching the given name in this class.
   `MethodNode` | `getDeclaredMethod(java.lang.String name, Parameter[] parameters)` Finds a method matching the given name and parameters in this class or any parent class.
   `java.util.List` | `getDeclaredMethods(java.lang.String name)` This methods returns a list of all methods of the given name defined in the current class
   `java.util.Map` | `getDeclaredMethodsMap()`
   `MethodNode` | `getEnclosingMethod()`
   `FieldNode` | `getField(java.lang.String name)` @return the field node on the outer class or null if this is not an inner class
   `java.util.List` | `getFields()` @return the array of interfaces which this ClassNode implements
   `GenericsType[]` | `getGenericsTypes()`
   `MethodNode` | `getGetterMethod(java.lang.String getterName)`
   `java.util.Iterator` | `getInnerClasses()`
   `ClassNode[]` | `getInterfaces()`
   `MethodNode` | `getMethod(java.lang.String name, Parameter[] parameters)` @param type the ClassNode of interest
   `java.util.List` | `getMethods()` @return the list of abstract methods associated with this ClassNode or null if there are no such methods
   `java.util.List` | `getMethods(java.lang.String name)`
   `MixinNode[]` | `getMixins()` @return the list of methods associated with this ClassNode
   `int` | `getModifiers()`
   `ModuleNode` | `getModule()`
   `java.lang.String` | `getName()`
   `java.lang.String` | `getNameWithoutPackage()`
   `java.util.List` | `getObjectInitializerStatements()`
   `ClassNode` | `getOuterClass()`
   `FieldNode` | `getOuterField(java.lang.String name)` Helper method to avoid casting to inner class
   `PackageNode` | `getPackage()`
   `java.lang.String` | `getPackageName()`
   `ClassNode` | `getPlainNodeReference()`
   `java.util.List` | `getProperties()`
   `PropertyNode` | `getProperty(java.lang.String name)`
   `MethodNode` | `getSetterMethod(java.lang.String setterName)` Is this class declared in a static method (such as a closure / inner class declared in a static method)
   `MethodNode` | `getSetterMethod(java.lang.String setterName, boolean voidOnly)`
   `ClassNode` | `getSuperClass()`
   `java.lang.String` | `getText()`
   `java.util.Map` | `getTransforms(CompilePhase phase)` @return iterator of inner classes defined inside this one
   `java.lang.Class` | `getTypeClass()`
   `ClassNode[]` | `getUnresolvedInterfaces()`
   `ClassNode[]` | `getUnresolvedInterfaces(boolean useRedirect)`
   `java.lang.String` | `getUnresolvedName()`
   `ClassNode` | `getUnresolvedSuperClass()`
   `ClassNode` | `getUnresolvedSuperClass(boolean useRedirect)`
   `boolean` | `hasDeclaredMethod(java.lang.String name, Parameter[] parameters)` @see #getDeclaredMethod(String, Parameter[])
   `boolean` | `hasMethod(java.lang.String name, Parameter[] parameters)`
   `boolean` | `hasPackageName()`
   `boolean` | `hasPossibleMethod(java.lang.String name, Expression arguments)`
   `boolean` | `hasPossibleStaticMethod(java.lang.String name, Expression arguments)` Returns true if the given method has a possibly matching static method with the given name and arguments.
   `boolean` | `hasProperty(java.lang.String name)`
   `int` | `hashCode()`
   `boolean` | `implementsInterface(ClassNode classNode)`
   `boolean` | `isAnnotated()`
   `boolean` | `isAnnotationDefinition()`
   `boolean` | `isArray()`
   `boolean` | `isDerivedFrom(ClassNode type)` @return true if this class is derived from a groovy object i.e. it implements GroovyObject
   `boolean` | `isDerivedFromGroovyObject()`
   `boolean` | `isEnum()`
   `boolean` | `isGenericsPlaceHolder()`
   `boolean` | `isInterface()` Returns the concrete class this classnode relates to.
   `boolean` | `isPrimaryClassNode()` @return true if this instance is a primary ClassNode
   `boolean` | `isRedirectNode()`
   `boolean` | `isResolved()`
   `boolean` | `isScript()`
   `boolean` | `isScriptBody()`
   `boolean` | `isStaticClass()`
   `boolean` | `isSyntheticPublic()`
   `boolean` | `isUsingGenerics()`
   `ClassNode` | `makeArray()`
   `protected boolean` | `parametersEqual(Parameter[] a, Parameter[] b)`
   `void` | `positionStmtsAfterEnumInitStmts(java.util.List staticFieldStatements)`
   `ClassNode` | `redirect()` Sets this instance as proxy for the given ClassNode.
   `void` | `removeField(java.lang.String oldName)`
   `void` | `renameField(java.lang.String oldName, java.lang.String newName)`
   `void` | `setAnnotated(boolean flag)`
   `protected void` | `setCompileUnit(CompileUnit cu)`
   `void` | `setEnclosingMethod(MethodNode enclosingMethod)`
   `void` | `setGenericsPlaceHolder(boolean b)`
   `void` | `setGenericsTypes(GenericsType[] genericsTypes)`
   `void` | `setInterfaces(ClassNode[] interfaces)` @return the array of mixins associated with this ClassNode
   `void` | `setModifiers(int modifiers)`
   `void` | `setModule(ModuleNode module)`
   `java.lang.String` | `setName(java.lang.String name)`
   `void` | `setRedirect(ClassNode cn)`
   `void` | `setScript(boolean script)`
   `void` | `setScriptBody(boolean scriptBody)`
   `void` | `setStaticClass(boolean staticClass)`
   `void` | `setSuperClass(ClassNode superClass)` Sets the superclass of this ClassNode
   `void` | `setSyntheticPublic(boolean syntheticPublic)`
   `void` | `setUnresolvedSuperClass(ClassNode sn)`
   `void` | `setUsingGenerics(boolean b)`
   `java.lang.String` | `toString()`
   `java.lang.String` | `toString(boolean showRedirect)`
   `MethodNode` | `tryFindPossibleMethod(java.lang.String name, Expression arguments)`
   `void` | `visitContents(GroovyClassVisitor visitor)`

   Methods inherited from class AnnotatedNode
   addAnnotation, addAnnotations, getAnnotations, getAnnotations, getDeclaringClass, hasNoRealSourcePosition, isSynthetic, setDeclaringClass, setHasNoRealSourcePosition, setSynthetic

   Methods inherited from class ASTNode
   copyNodeMetaData, getColumnNumber, getLastColumnNumber, getLastLineNumber, getLineNumber, getNodeMetaData, getText, putNodeMetaData, removeNodeMetaData, setColumnNumber, setLastColumnNumber, setLastLineNumber, setLineNumber, setNodeMetaData, setSourcePosition, visit

   Methods inherited from class java.lang.Object
   java.lang.Object#wait(long), java.lang.Object#wait(long, int), java.lang.Object#wait(), java.lang.Object#equals(java.lang.Object), java.lang.Object#toString(), java.lang.Object#hashCode(), java.lang.Object#getClass(), java.lang.Object#notify(), java.lang.Object#notifyAll()

   Field Detail

   ### EMPTY_ARRAY

       public static final ClassNode[] EMPTY_ARRAY

   ### SUPER

       public static final ClassNode SUPER

   ### THIS

       public static final ClassNode THIS

   ### clazz

       protected java.lang.Class clazz

   ### innerClasses

       protected java.util.List innerClasses

   ### isPrimaryNode

       protected boolean isPrimaryNode

   ### lazyInitLock

       protected java.lang.Object lazyInitLock

   Method Detail

   ### ClassNode

       public java.lang.Object ClassNode(java.lang.Class c)

   ### ClassNode

       public java.lang.Object ClassNode(java.lang.String name, int modifiers, ClassNode superClass)

   ### ClassNode

       public java.lang.Object ClassNode(java.lang.String name, int modifiers, ClassNode superClass, ClassNode[] interfaces, MixinNode[] mixins)

   ### addConstructor

       public void addConstructor(ConstructorNode node)

   ### addConstructor

       public ConstructorNode addConstructor(int modifiers, Parameter[] parameters, ClassNode[] exceptions, Statement code)

   ### addField

       public void addField(FieldNode node)

   ### addField

       public FieldNode addField(java.lang.String name, int modifiers, ClassNode type, Expression initialValue)

   ### addFieldFirst

       public void addFieldFirst(FieldNode node)

   ### addFieldFirst

       public FieldNode addFieldFirst(java.lang.String name, int modifiers, ClassNode type, Expression initialValue)

   ### addInterface

       public void addInterface(ClassNode type)

   ### addMethod

       public void addMethod(MethodNode node)

   ### addMethod

       public MethodNode addMethod(java.lang.String name, int modifiers, ClassNode returnType, Parameter[] parameters, ClassNode[] exceptions, Statement code)

   ### addMixin

       public void addMixin(MixinNode mixin)

   ### addObjectInitializerStatements

       public void addObjectInitializerStatements(Statement statements)

   ### addProperty

       public void addProperty(PropertyNode node)

   ### addProperty

       public PropertyNode addProperty(java.lang.String name, int modifiers, ClassNode type, Expression initialValueExpression, Statement getterBlock, Statement setterBlock)

   ### addStaticInitializerStatements

       public void addStaticInitializerStatements(java.util.List staticStatements, boolean fieldInit)

   ### addSyntheticMethod

       public MethodNode addSyntheticMethod(java.lang.String name, int modifiers, ClassNode returnType, Parameter[] parameters, ClassNode[] exceptions, Statement code)

   ### addTransform

       public void addTransform(java.lang.Class transform, ASTNode node)

   ### declaresInterface

       public boolean declaresInterface(ClassNode classNode)

     Returns:
       the ClassNode of the super class of this type

   ### equals

       public boolean equals(java.lang.Object o)

   ### getAbstractMethods

       public java.util.List getAbstractMethods()

   ### getAllDeclaredMethods

       public java.util.List getAllDeclaredMethods()

   ### getAllInterfaces

       public java.util.Set getAllInterfaces()

   ### getAnnotations

       public java.util.List getAnnotations()

   ### getAnnotations

       public java.util.List getAnnotations(ClassNode type)

   ### getCompileUnit

       public CompileUnit getCompileUnit()

   ### getComponentType

       public ClassNode getComponentType()

   ### getDeclaredConstructors

       public java.util.List getDeclaredConstructors()

   ### getDeclaredField

       public FieldNode getDeclaredField(java.lang.String name)

     Finds a field matching the given name in this class.
     Parameters:
       `name` - the name of the field of interest
     Returns:
       the method matching the given name and parameters or null

   ### getDeclaredMethod

       public MethodNode getDeclaredMethod(java.lang.String name, Parameter[] parameters)

     Finds a method matching the given name and parameters in this class or any parent class.
     Returns:
       the method matching the given name and parameters or null

   ### getDeclaredMethods

       public java.util.List getDeclaredMethods(java.lang.String name)

     This methods returns a list of all methods of the given name defined in the current class
     Returns:
       the method list
     See Also:
       getMethods(String)

   ### getDeclaredMethodsMap

       public java.util.Map getDeclaredMethodsMap()

   ### getEnclosingMethod

       public MethodNode getEnclosingMethod()

   ### getField

       public FieldNode getField(java.lang.String name)

     Returns:
       the field node on the outer class or null if this is not an inner class

   ### getFields

       public java.util.List getFields()

     Returns:
       the array of interfaces which this ClassNode implements

   ### getGenericsTypes

       public GenericsType[] getGenericsTypes()

   ### getGetterMethod

       public MethodNode getGetterMethod(java.lang.String getterName)

   ### getInnerClasses

       public java.util.Iterator getInnerClasses()

   ### getInterfaces

       public ClassNode[] getInterfaces()

   ### getMethod

       public MethodNode getMethod(java.lang.String name, Parameter[] parameters)

     Parameters:
       `type` - the ClassNode of interest
     Returns:
       true if this node is derived from the given ClassNode

   ### getMethods

       public java.util.List getMethods()

     Returns:
       the list of abstract methods associated with this ClassNode or null if there are no such methods

   ### getMethods

       public java.util.List getMethods(java.lang.String name)

   ### getMixins

       public MixinNode[] getMixins()

     Returns:
       the list of methods associated with this ClassNode

   ### getModifiers

       public int getModifiers()

   ### getModule

       public ModuleNode getModule()

   ### getName

       public java.lang.String getName()

   ### getNameWithoutPackage

       public java.lang.String getNameWithoutPackage()

   ### getObjectInitializerStatements

       public java.util.List getObjectInitializerStatements()

   ### getOuterClass

       public ClassNode getOuterClass()

   ### getOuterField

       public FieldNode getOuterField(java.lang.String name)

     Helper method to avoid casting to inner class

   ### getPackage

       public PackageNode getPackage()

   ### getPackageName

       public java.lang.String getPackageName()

   ### getPlainNodeReference

       public ClassNode getPlainNodeReference()

   ### getProperties

       public java.util.List getProperties()

   ### getProperty

       public PropertyNode getProperty(java.lang.String name)

   ### getSetterMethod

       public MethodNode getSetterMethod(java.lang.String setterName)

     Is this class declared in a static method (such as a closure / inner class declared in a static method)

   ### getSetterMethod

       public MethodNode getSetterMethod(java.lang.String setterName, boolean voidOnly)

   ### getSuperClass

       public ClassNode getSuperClass()

   ### getText

       public java.lang.String getText()

   ### getTransforms

       public java.util.Map getTransforms(CompilePhase phase)

     Returns:
       iterator of inner classes defined inside this one

   ### getTypeClass

       public java.lang.Class getTypeClass()

   ### getUnresolvedInterfaces

       public ClassNode[] getUnresolvedInterfaces()

   ### getUnresolvedInterfaces

       public ClassNode[] getUnresolvedInterfaces(boolean useRedirect)

   ### getUnresolvedName

       public java.lang.String getUnresolvedName()

   ### getUnresolvedSuperClass

       public ClassNode getUnresolvedSuperClass()

   ### getUnresolvedSuperClass

       public ClassNode getUnresolvedSuperClass(boolean useRedirect)

   ### hasDeclaredMethod

       public boolean hasDeclaredMethod(java.lang.String name, Parameter[] parameters)

     See Also:
       getDeclaredMethod(String, Parameter[])

   ### hasMethod

       public boolean hasMethod(java.lang.String name, Parameter[] parameters)

   ### hasPackageName

       public boolean hasPackageName()

   ### hasPossibleMethod

       public boolean hasPossibleMethod(java.lang.String name, Expression arguments)

   ### hasPossibleStaticMethod

       public boolean hasPossibleStaticMethod(java.lang.String name, Expression arguments)

     Returns true if the given method has a possibly matching static method with the given name and arguments.
     Parameters:
       `name` - the name of the method of interest
       `arguments` - the arguments to match against
     Returns:
       true if a matching method was found

   ### hasProperty

       public boolean hasProperty(java.lang.String name)

   ### hashCode

       public int hashCode()

   ### implementsInterface

       public boolean implementsInterface(ClassNode classNode)

   ### isAnnotated

       public boolean isAnnotated()

   ### isAnnotationDefinition

       public boolean isAnnotationDefinition()

   ### isArray

       public boolean isArray()

   ### isDerivedFrom

       public boolean isDerivedFrom(ClassNode type)

     Returns:
       true if this class is derived from a groovy object i.e. it implements GroovyObject

   ### isDerivedFromGroovyObject

       public boolean isDerivedFromGroovyObject()

   ### isEnum

       public boolean isEnum()

   ### isGenericsPlaceHolder

       public boolean isGenericsPlaceHolder()

   ### isInterface

       public boolean isInterface()

     Returns the concrete class this classnode relates to. However, this method is inherently unsafe as it may return null depending on the compile phase you are using. AST transformations should never use this method directly, but rather obtain a new class node using getPlainNodeReference().
     Returns:
       the class this classnode relates to. May return null.

   ### isPrimaryClassNode

       public boolean isPrimaryClassNode()

     Returns:
       true if this instance is a primary ClassNode

   ### isRedirectNode

       public boolean isRedirectNode()

   ### isResolved

       public boolean isResolved()

   ### isScript

       public boolean isScript()

   ### isScriptBody

       public boolean isScriptBody()

   ### isStaticClass

       public boolean isStaticClass()

   ### isSyntheticPublic

       public boolean isSyntheticPublic()

   ### isUsingGenerics

       public boolean isUsingGenerics()

   ### makeArray

       public ClassNode makeArray()

   ### parametersEqual

       protected boolean parametersEqual(Parameter[] a, Parameter[] b)

   ### positionStmtsAfterEnumInitStmts

       public void positionStmtsAfterEnumInitStmts(java.util.List staticFieldStatements)

   ### redirect

       public ClassNode redirect()

     Sets this instance as proxy for the given ClassNode.
     Parameters:
       `cn` - the class to redirect to. If set to null the redirect will be removed

   ### removeField

       public void removeField(java.lang.String oldName)

   ### renameField

       public void renameField(java.lang.String oldName, java.lang.String newName)

   ### setAnnotated

       public void setAnnotated(boolean flag)

   ### setCompileUnit

       protected void setCompileUnit(CompileUnit cu)

   ### setEnclosingMethod

       public void setEnclosingMethod(MethodNode enclosingMethod)

   ### setGenericsPlaceHolder

       public void setGenericsPlaceHolder(boolean b)

   ### setGenericsTypes

       public void setGenericsTypes(GenericsType[] genericsTypes)

   ### setInterfaces

       public void setInterfaces(ClassNode[] interfaces)

     Returns:
       the array of mixins associated with this ClassNode

   ### setModifiers

       public void setModifiers(int modifiers)

   ### setModule

       public void setModule(ModuleNode module)

   ### setName

       public java.lang.String setName(java.lang.String name)

   ### setRedirect

       public void setRedirect(ClassNode cn)

   ### setScript

       public void setScript(boolean script)

   ### setScriptBody

       public void setScriptBody(boolean scriptBody)

   ### setStaticClass

       public void setStaticClass(boolean staticClass)

   ### setSuperClass

       public void setSuperClass(ClassNode superClass)

     Sets the superclass of this ClassNode

   ### setSyntheticPublic

       public void setSyntheticPublic(boolean syntheticPublic)

   ### setUnresolvedSuperClass

       public void setUnresolvedSuperClass(ClassNode sn)

   ### setUsingGenerics

       public void setUsingGenerics(boolean b)

   ### toString

       public java.lang.String toString()

   ### toString

       public java.lang.String toString(boolean showRedirect)

   ### tryFindPossibleMethod

       public MethodNode tryFindPossibleMethod(java.lang.String name, Expression arguments)

   ### visitContents

       public void visitContents(GroovyClassVisitor visitor)

   Groovy Documentation